import greenfoot.*;// (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.*;//enable list's
/**
 * MY class
 * 
 * @author Tyler Hanson 
 * @version Date edited: 12-24-2010
 */
public class Tyler  extends Actor
{
    GreenfootImage[] images = new GreenfootImage[3];//images of player
    
    /** total health */
    static int Health = 100;//total health
    
    /** how fast health regenerates */
    private int healthRegenCount;//health regenerate slowly
    
    /** movement speed */
    private int Speed = 2;//how fast the player moves
    static int facing;//var storing player's direction
    
    /** mouse location */
    static int mouseX;
    static int mouseY;
    private String keyDown = "";
    
    /** GUNS */
    //number of the guns
    // 0 = pistol
    // 1 = machine gun
    // 2 = flamethrower
    static int Gun = 0;//what gun you have
                       //0 = pistol
                       //1 = minigun
                       //2 = flamethrower
    private boolean shoot;//to shoot or not to shoot
    private int x;//pistol shoot frequency when mouse click held
    
    /** Traps */
    private int trapReload;//counter so you cant place all mines at once
    static int totalMines = 10;//total number of starting mines
    
    /** stats */
    static int pistolKills;//total pistol kills
    static int flamethrowerKills;//total flamethrower kills
    static int minigunKills;//total minigun kills
    static int landmineKills;//landmine kills
    
    /** Hud info */
    HUD health = new HUD("playerhealth");//create player health bar
    Text mines = new Text("numofmines");//create text displaying total mines
    Text zobis = new Text("zobisleft");//create text displaying total zombies left
    MouseInfo mouse;
    
    public Tyler() {
        Health = 100;
        totalMines = 10;
        Gun = 0;
    }
    
    protected void addedToWorld(World world) {
        images[0] = new GreenfootImage("Player/Tyler[pistol].png");
        images[1] = new GreenfootImage("Player/Tyler[minigun].png");
        images[2] = new GreenfootImage("Player/Tyler[flamethrower].png");
        setImage(images[Gun]);
        getWorld().addObject(health,154,12);
        getWorld().addObject(mines,70,40);
        getWorld().addObject(zobis,77,55);
    }
    
    public void act() {
        facing = getRotation();
        /** set image to current weapons */ 
        setImage(images[Gun]);//set image according to current gun
        commandAlly();//ally method
        dropinTraps();//trap method
        Movement();//movement method
        shootinGunz();//gun method
        /** pickin up a gun */
        Guns gun = (Guns)getOneIntersectingObject(Guns.class);
        if(gun != null) {
            this.Gun = gun.type;
            getWorld().removeObject(gun);
        }
        /**Zobi all gone!! */
        HealthRegen();//health regen if no zombies nearby
    }    
    
    public void Movement() {
        /** Movement */
        if(Greenfoot.isKeyDown("w")) {//move up
            setLocation(getX(), getY() - Speed);
        }
        if(Greenfoot.isKeyDown("s")) {//move down
            setLocation(getX(), getY() + Speed);
        }
        if(Greenfoot.isKeyDown("a")) {//move left
            setLocation(getX() - Speed, getY());
        }
        if(Greenfoot.isKeyDown("d")) {//move right
            setLocation(getX() + Speed, getY());
        }
        /** point player at mouse */
        if(Greenfoot.mouseMoved(null) || Greenfoot.mouseDragged(null)) {
            mouse = Greenfoot.getMouseInfo();
            mouseX = mouse.getX();//store mouse's X coordinate
            mouseY = mouse.getY();//store mouse's Y corrdinate
        }
        setRotation(pointTo(mouseX,mouseY));//point player at mouse's coordinates
    }
    
    public void shootinGunz() {
        if(Greenfoot.mousePressed(null)) {//if mouse held able to continue shooting
            shoot = true;
            x = 15;
        }
        if(Greenfoot.mouseClicked(null))//player stop's shooting
            shoot = false;
        /** normal shooting */
        x++;
        if(shoot == true && Gun == 0 && x >= 15) {//shoot bullet if player has a pistol,mouse button clicked/held
            getWorld().addObject(new Bullet((getRotation() - 5) + Greenfoot.getRandomNumber(10)),getX(),getY());
            x = 0;
        }
        /** rapid shooting */
        if(shoot == true && Gun == 1)//shoot bullets when mouse button clicked/held and player has a minigun
            getWorld().addObject(new Bullet((getRotation() - 5) + Greenfoot.getRandomNumber(10)),getX(),getY());
        if(shoot == true && Gun == 2)//shoot fire when mouse button clicked/held and player has a flamethrower
            for(int i=0;i<Greenfoot.getRandomNumber(5) + 5;i++)
                getWorld().addObject(new Fire((getRotation() - 10) + Greenfoot.getRandomNumber(20)),getX(),getY());
    }
    
    public void HealthRegen() {
        List<Zobi> Zobi = getObjectsInRange(20,Zobi.class);//get zobi's in range
        /** no zobi's nearby */
        if(Zobi.size() == 0 && healthRegenCount == 3) {//regenerate health if no zobi's nearby
            Health++;
            if(Health >= 100)
                Health = 100;
            healthRegenCount = 0;
        } else if(healthRegenCount < 3) {
            healthRegenCount++;
        }
        /** create player body parts upon death */
        if(Health <= 0) {//player has died and body parts start ah flyin
            getWorld().addObject(new bodyParts("arm",Greenfoot.getRandomNumber(5) + 2,Greenfoot.getRandomNumber(15) + 10,Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(360)),getX(), getY());
            getWorld().addObject(new bodyParts("arm",Greenfoot.getRandomNumber(5) + 2,Greenfoot.getRandomNumber(15) + 10,Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(360)),getX(), getY());
            getWorld().addObject(new bodyParts("leg",Greenfoot.getRandomNumber(5) + 2,Greenfoot.getRandomNumber(15) + 10,Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(360)),getX(), getY());
            getWorld().addObject(new bodyParts("leg",Greenfoot.getRandomNumber(5) + 2,Greenfoot.getRandomNumber(15) + 10,Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(360)),getX(), getY());
            getWorld().addObject(new bodyParts("head",Greenfoot.getRandomNumber(5) + 2,Greenfoot.getRandomNumber(15) + 10,Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(360)),getX(), getY());
            getWorld().addObject(new bodyParts("body",Greenfoot.getRandomNumber(5) + 2,Greenfoot.getRandomNumber(15) + 10,Greenfoot.getRandomNumber(360),Greenfoot.getRandomNumber(360)),getX(), getY());
            //getWorld().addObject(new Stats(),-300,getWorld().getHeight()/2);
            getWorld().removeObject(this);
        }
    }
    
    public void dropinTraps() {
        if(totalMines > 0 && Greenfoot.isKeyDown("q") && trapReload == 20) {//drop mine if you have one and button pressed
            getWorld().addObject(new Mine(),getX(),getY());
            trapReload = 0;
            totalMines--;
        } else if(trapReload < 20){
            trapReload++;
        }
    }
    
    public void commandAlly() {
        if(Greenfoot.isKeyDown("z"))//ally hold position
            AllyPlacer.follow = false;
        if(Greenfoot.isKeyDown("x"))//ally follow
            AllyPlacer.follow = true;
    }
    
    public int pointTo(int x, int y) {
        int dX = x - getX();//get distance between mouse's X and player's X
        int dY = y - getY();//get distance between mouse's Y and player's Y
        double rotation = Math.atan2(dY, dX); 
        rotation = Math.toDegrees(rotation); 
        return (int)rotation; 
    } 
}
